<template>
    <div class="barchart">
        <canvas ref="canvasElement" width="250" height="250"/>
    </div>
</template>

<script>
import {Chart} from '../shared/chart'
import * as colors from '../shared/colors.js'
export default {
    data() {
        return {
            chart: undefined,
        }
    },
    mounted() {
        this.subscriptionUpdated()
    },
    computed: {
        selectedFruitBasket() {
            return this.$store.state.selectedFruitBasket
        }
    },
    watch: {
        selectedFruitBasket() {
            this.subscriptionUpdated()
        }
    },
    methods: {
        subscriptionUpdated() {
            if (!this.$refs.canvasElement) return;
            if (!this.chart) {
                this.initChart()
            } else {
                this.updateChart()
            }
        },
        initChart() {
            this.chart = new Chart(this.$refs.canvasElement, {
            type: 'bar',
            data: {
                datasets: [{
                data: [
                    this.selectedFruitBasket.nApples,
                    this.selectedFruitBasket.nOranges
                ],
                backgroundColor: [colors.red, colors.orange],
                }],
                labels: ['Apples', 'Oranges'],
            },
            options: {
                legend: {
                display: false,
                },
                scales: {
                xAxes: [{
                    barPercentage: 0.75,
                    gridLines: {
                    color: colors.lightGray,
                    },
                }],
                yAxes: [{
                    gridLines: {
                    color: colors.lightGray,
                    zeroLineColor: colors.lightGray,
                    },
                    ticks: {
                    beginAtZero: true,
                    callback: () => '',
                    suggestedMax: this.selectedFruitBasket.nApples + this.selectedFruitBasket.nOranges,
                    suggestedMin: 0,
                    }
                }],
                },
            },
            });
        },
        updateChart() {
            this.chart.data.datasets[0].data = [
                this.selectedFruitBasket.nApples,
                this.selectedFruitBasket.nOranges,
            ];

            this.chart.options.scales.yAxes[0].ticks.suggestedMax = this.selectedFruitBasket.nApples + this.selectedFruitBasket.nOranges;

            this.chart.update();
        }
    }
}
</script>

<style lang="scss" scoped>
@import '../styles/_variables';

.barchart {
  background-color: $white;
  border-radius: 0.5rem;
  box-shadow: 1px 1px 3px $gray;
  overflow: hidden;
  padding: 2rem;
  width: 250px;
  height: 250px;
}

canvas {
  pointer-events: none;
}
</style>
